/////////////////////////////////////////////////////////////////////////////
// Name:        capture.cpp
// Purpose:     
// Author:      jrg piringer
// Modified by: 
// Created:     19/05/2006 23:22:42
// RCS-ID:      
// Copyright:   
// Licence:     LGPL
/////////////////////////////////////////////////////////////////////////////

#include "OSCWindow.h"
#include "capture.h"

void OSCProcess::OnTerminate(int pid, int status)
{
    m_parent->SetStatusText(wxString::Format(_T("%u terminated EC: %d"),
                pid, status));

    // we're not needed any more
    delete this;
}

bool OSCPipedProcess::HasInput()
{
    bool hasInput = false;

    if(IsInputAvailable())
    {
        wxTextInputStream tis(*GetInputStream());

        // this assumes that the output is always line buffered
        wxString msg;
        msg << m_cmd << _T(" (stdout): ") << tis.ReadLine();

        m_parent->AppendLog(msg);

        hasInput = true;
    }

    if(IsErrorAvailable())
    {
        wxTextInputStream tis(*GetErrorStream());

        // this assumes that the output is always line buffered
        wxString msg;
        //msg << m_cmd << _T(" (stderr): ") << tis.ReadLine();

        m_parent->AppendLog(tis.ReadLine());
        hasInput = true;
    }

    return hasInput;
}

void OSCPipedProcess::OnTerminate(int pid, int status)
{
    // show the rest of the output
    while(HasInput())
        ;

    m_parent->OnProcessTerminated(this,nbpage);

    OSCProcess::OnTerminate(pid, status);
}
